
Figure - Bug #115182
【AF】【EVT2】【10/10】【Volume】重启DUT后，音量从100%变回50%
2023-01-09 16:38 - CDTS_TEST 刘勇

Status: CLOSED Start date: 2023-01-09

Priority: Normal Due date: 2023-02-02

Assignee: CD Test赵飞 % Done: 100%

Category: LC Estimated time: 0.00 hour

Target version:

Need_Info: -- Found Version: FlatBuild_HH_VX1_MCE_FSE.M.D.user.01.00.X101.202301080304

Resolution: -- Degrated: --

Severity: Major Verified Version:

Reproducibility: Every time Fixed Version:

Test Type: ST Root cause:

Description

【前提条件】

1.设备刷机

2.连接蓝牙耳机

【测试步骤】

1.调整蓝牙耳机音量到100%

2.重启副屏（adb reboot）

【预期结果】

2.音量和开机前一致

【实际结果】

2.音量从100%变回50%

【复现概率】

必现

【备注】从任何一个非50%音量重启都会变回50%

History

#1 - 2023-01-09 17:36 - CD FW-廖涛

- Assignee changed from CD FW-廖涛 to CD FW 曹覃刚

#2 - 2023-01-09 18:19 - CD FW 曹覃刚

- Category changed from CD-FW to AUDIO-FW

- Assignee changed from CD FW 曹覃刚 to CD MM陈海波

Hi 海波

这应该是个正常现象，请帮忙确认一下

#3 - 2023-01-11 17:05 - CD MM陈海波

- Due date set to 2023-01-17

#4 - 2023-01-16 11:53 - CD MM陈海波

- File logcat.txt added

- Category changed from AUDIO-FW to LC
- Assignee changed from CD MM陈海波 to CD LC 陶洪普

从log进行分析, 主要原因是蓝牙传过来的音量为19(50%)导致. 

以下为音量传过来的调用栈.

10-31 13:10:41.270  2065  2781 D bt_btif : bta_ag_at_hfp_cback: AT command 19, arg_type 2, int_arg 0, arg 0

10-31 13:10:42.199  2065  2242 D A2dpService: volume = 19

10-31 13:10:42.199  2065  2242 E AudioManager: handleBluetoothA2dpActiveDeviceChange a2dpVolume= 19

10-31 13:10:42.199  2065  2242 E AudioManager: java.lang.Throwable

10-31 13:10:42.199  2065  2242 E AudioManager:     at android.media.AudioManager.handleBluetoothA2dpActiveDeviceChange(AudioManager.java:5891)

10-31 13:10:42.199  2065  2242 E AudioManager:     at com.android.bluetooth.a2dp.A2dpService.setActiveDeviceInternal(A2dpService.java:1135)

10-31 13:10:42.199  2065  2242 E AudioManager:     at com.android.bluetooth.a2dp.A2dpService.startSHO(A2dpService.java:1033)

10-31 13:10:42.199  2065  2242 E AudioManager:     at com.android.bluetooth.avrcp.Avrcp_ext.startSHO(Avrcp_ext.java:5237)

10-31 13:10:42.199  2065  2242 E AudioManager:     at com.android.bluetooth.a2dp.A2dpService.setActiveDevice(A2dpService.java:997)

10-31 13:10:42.199  2065  2242 E AudioManager:     at

com.android.bluetooth.btservice.ActiveDeviceManager.setA2dpActiveDevice(ActiveDeviceManager.java:550)

10-31 13:10:42.199  2065  2242 E AudioManager:     at com.android.bluetooth.btservice.ActiveDeviceManager.access$400(ActiveDeviceManager.java:106)

10-31 13:10:42.199  2065  2242 E AudioManager:     at

com.android.bluetooth.btservice.ActiveDeviceManager$ActiveDeviceManagerHandler.handleMessage(ActiveDeviceManager.java:232)

10-31 13:10:42.199  2065  2242 E AudioManager:     at android.os.Handler.dispatchMessage(Handler.java:106)

10-31 13:10:42.199  2065  2242 E AudioManager:     at android.os.Looper.loopOnce(Looper.java:201)

10-31 13:10:42.199  2065  2242 E AudioManager:     at android.os.Looper.loop(Looper.java:288)

10-31 13:10:42.199  2065  2242 E AudioManager:     at android.os.HandlerThread.run(HandlerThread.java:67)

这个音量是蓝牙模块设置的. 

从代码和现象看, 好像是正常的表现行为(似乎50%的音量还在是在蓝牙的VolumeManager.java中处理.).

但需要蓝牙模块确认下, 是否为正常的表现行为. 

什么样的场景蓝牙的音量才会进行保存.

多谢!

#5 - 2023-01-17 23:54 - CD LC 陶洪普

- Status changed from New to ASSIGNED

更新:

蓝牙耳机设置的音量保存在下面perfeence文件中.

cat /data/user_de/0/com.android.bluetooth/shared_prefs/bluetooth_volume_map.xml

<map>

    <int name="54:0E:2D:00:9F:C6" value="32" />

</map>

在断开蓝牙设备,和重启设备前, 系统会把保存当前用户配置到这个文件中.

我这边复测了几次, 概率性存在设备没有保存到这个文件中情况. 如果文件损坏,会设置默认值. 下一步, 确认在重启前后, 对用户设置音量的保存情况.

1.

#6 - 2023-01-30 14:05 - CD LC 陶洪普
该问题原始是：

重启时，设置的音量概率性未保存下来。

修改为：在每次变更音量，及时保存设置（原处理逻辑：在耳机断开和关机时保存）

#7 - 2023-01-30 14:05 - CD LC 陶洪普

- Due date changed from 2023-01-17 to 2023-02-02

#8 - 2023-01-30 21:18 - CD LC 陶洪普

提交patch，本地验证OK.

https://dev.thundercomm.com/gerrit/c/general/platform/vendor/qcom-opensource/bluetooth_ext/+/178201

编译VB-user版本 编译中

http://10.0.76.24:8080/job/VerifyBuild_for_IOT_6490/2389/

#9 - 2023-01-30 21:18 - CD LC 陶洪普

- % Done changed from 0 to 40

#10 - 2023-02-02 23:07 - CD LC 陶洪普

- % Done changed from 40 to 50

提交patch，本地验证OK.

https://dev.thundercomm.com/gerrit/c/general/platform/vendor/qcom-opensource/bluetooth_ext/+/178201

编译VB-user版本 编译中

http://10.0.76.24:8080/job/VerifyBuild_for_IOT_6490/2389/

上面VB user版本已自验证pass.

下一步，review后申请入库。

#11 - 2023-02-04 01:26 - IoT scm

Gerrit Merge Information：

ID Project Branch Uploader

178201 general/platform/vendor/qcom-opens

ource/bluetooth_ext

Pre_figure_turbox-c2130c-la1.1-qssi12

-dev

taohp0107@thundersoft.com

LC:BT: Save the volume setting in time when the volume is changedWhen shutting down the device and BT avrcp has been connected, afterreceived

Intent.ACTION_SHUTDOWN to trigger saving the volume,but it is not saved sometimes.Therefore, when the volume is changed, save the volume in

time.TC-RID: 1200-0400102IssueID: TS-R-BUG-115182Change-Id: I5fc70a44807a0173a5179620bb1721423b15da86

#12 - 2023-02-04 17:08 - CD LC 陶洪普

- Status changed from ASSIGNED to RESOLVED

- Assignee changed from CD LC 陶洪普 to 物联网测试组_CDTS 段小刚

- % Done changed from 50 to 70
Hi 小刚，

请参照 上一条scm自动更新的patch信息，已Merged.

请使用2/5日及之后的DB版本回归测试，谢谢！

#13 - 2023-02-06 16:53 - 物联网测试组_CDTS 段小刚

- Status changed from RESOLVED to VERIFY_FAILED

- Assignee changed from 物联网测试组_CDTS 段小刚 to CD LC 陶洪普

验证版本：FlatBuild_HH_VX1_MCE_FSE.M.D.user.01.00.X101.202302050304

验证结果：其蓝牙耳机音量在reboot之后，仍然会回到50%——Fail

#14 - 2023-02-06 21:59 - CD LC 陶洪普

验证结果：其蓝牙耳机音量在reboot之后，仍然会回到50%——Fail

已和测试确认, 这个是不同的耳机的兼容.

使用Vivo TWS Neo, 爱国者 测试没有问题. OPPO Enco WS1 有问题.

该问题是在修改音量的时候保存音量设置到xml文件中. 对于不支持Absolute volume 的耳机未修改到.

#15 - 2023-02-08 23:30 - IoT scm

Gerrit Merge Information：

ID Project Branch Uploader

180263 general/platform/vendor/qcom-opens

ource/bluetooth_ext

Pre_figure_turbox-c2130c-la1.1-qssi12

-dev

taohp0107@thundersoft.com

LC:BT: Store volume in AvrcpVolumeChangeReceiverWhen shutting down the device and avrcp is still connected, sometimesthere is not enough time to save

volume. For the devices unsupportedabsolute volume , the volume is not saved in previous change.So change saving volume in

AvrcpVolumeChangeReceiver.TC-RID: 1200-0400102IssueID: TS-R-BUG-115182Change-Id: I0b49b9364bd19cd24b3bd321724a3992dabf5e04

#16 - 2023-02-09 17:20 - CD LC 陶洪普

- Status changed from VERIFY_FAILED to RESOLVED

- Assignee changed from CD LC 陶洪普 to CD Test赵飞

Hi 赵飞，　王成，　小刚

上面patch修改已包含（不支持绝对音量的耳机），　请帮验证．

（该问题提票时，未说明耳机型号，我们这边分析用的是Vivo TWS Neo耳机，后测试OPPO有问题（不支持绝对音量），原patch未覆盖到．先已包含 ）
谢谢！

#17 - 2023-02-10 10:57 - CD Test赵飞

- Status changed from RESOLVED to VERIFIED

- % Done changed from 70 to 80

验证版本：FlatBuild_HH_VX1_MCE_FSE.M.D.user.01.00.X101.202302100501

验证结果：PASS

验证了以下型号蓝牙耳机，音量在设备重启后，与重启前设置的值保持一致

HUAWEI FreeBuds Pro 2

VIVO TWS Neo

BIAZE D20

AUKEY EP-B52

Baseus Encok W04

Monster Clarity 101 AirLinks

#18 - 2023-02-10 10:57 - CD Test赵飞

- Status changed from VERIFIED to CLOSED

- % Done changed from 80 to 100

Files

Volume.txt 2.55 MB 2023-01-09 CDTS_TEST 刘勇

logcat.txt 2.84 MB 2023-01-16 CD MM陈海波
